type t = {
  verbose : bool;
  print_lemmas : bool;
  print_model : bool;
  excluded_variables : Proposition.t list;
}

let gather v l m x = { verbose = v; print_lemmas = l; print_model = m; excluded_variables = x }
let all_false = { verbose = false; print_lemmas = false; print_model = false; excluded_variables = [] }
let is_verbose = function
  | { verbose = true; print_lemmas = _ ; print_model = _; excluded_variables = _ } -> true
  | { verbose = false; print_lemmas = _; print_model = _; excluded_variables = _ } -> false

type 'a t_funs = {
  stat : (Stats.t -> 'a) -> 'a;
  lemma : (Lemmas.Info_lemmas.t -> 'a) -> 'a;
}

let to_funs { verbose = v; print_lemmas = l } ~default ~stats ~lemmas = {
  stat  = (if v then fun f -> f stats else fun _ -> default);
  lemma = (if l then fun f -> f lemmas else fun _ -> default);
}

let to_unit_funs = to_funs ~default:()
let to_string_funs = to_funs ~default:""
